(* This file is distributed under the terms of the MIT License, also
   known as the X11 Licence.  A copy of this license is in the README
   file that accompanied the original distribution of this file.

   Based on code written by:
     Brian Aydemir

   $Id: FSetsClassFacts.v 2731 2009-02-24 17:29:24Z baydemir $ *)

(** A library of assorted lemmas specifically for use with the
    LNgen tool (see http://www.cis.upenn.edu/~baydemir/). *)

Require Import FSetsClass.
Require Import FSetsClassDecide.
Require Import FSetsClassFacts.


(* *********************************************************************** *)
(** * Facts *)

Lemma Subset_union_lngen_open_upper :
  forall `{FSet A} (s1 s2 s3 s4 s5 : fset A),
  s1 [<=] s3 `union` s4 ->
  s2 [<=] s3 `union` s5 ->
  s1 `union` s2 [<=] s3 `union` s4 `union` s5.
Proof. fsetdec A. Qed.


(* *********************************************************************** *)
(** * Hints *)

(** From FSetsClassFacts. *)

Hint Rewrite @remove_empty : lngen.
Hint Rewrite @remove_singleton_same : lngen.
Hint Rewrite @remove_singleton_diff using solve [auto] : lngen.
Hint Rewrite @remove_union_distrib : lngen.

(** From this library. *)

Hint Resolve @Subset_union_lngen_open_upper : lngen.
